var vm = new Vue({
    el: '#app',
    delimiters: ['[[', ']]'],
    data: {
        host: host,

        error_username: false,
        error_password: false,
        error_check_password: false,
        error_phone: false,
        error_allow: false,
        error_image_code: false,
        error_sms_code:false,


        error_username_message: '请输入5-20个字符的用户',
        error_password_message: '请输入8-20位的密码',
        error_password2_message: '两次输入的密码不一致',
        error_phone_message: '请输入正确的手机号码',
        error_allow_message: '请勾选用户协议',
        error_image_code_message: '图形验证码错误',
        error_sms_code_message:'请填写短信验证码',

        image_code_id: '',
        image_code_url: '',
        username: '',
        password: '',
        password2: '',
        mobile: '',
        allow: true,
        image_code: '',
        sms_code:'',
        sms_code_tip: '获取短信验证码',
        sending_flag:false

    },
    mounted: function () {
        // 向服务器获取图片验证码
        this.generate_image_code();
    },
    methods: {
        generateUUID: function () {
            var d = new Date().getTime();
            if (window.performance && typeof window.performance.now === "function") {
                d += performance.now(); //use high-precision timer if available
            }
            var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = (d + Math.random() * 16) % 16 | 0;
                d = Math.floor(d / 16);
                return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
            });
            return uuid;
        },
        // 生成一个图片验证码的编号，并设置页面中图片验证码img标签的src属性
        generate_image_code: function () {
            // 生成一个编号 : 严格一点的使用uuid保证编号唯一， 不是很严谨的情况下，也可以使用时间戳
            this.image_code_id = this.generateUUID();
            // 设置页面中图片验证码img标签的src属性
            this.image_code_url = this.host + "/image_codes/" + this.image_code_id + "/";
            console.log(this.image_code_url);
        },
        // 校验字段1
        check_username: function () {
            // 匹配正则
            var re = /^[a-zA-Z0-9_-]{5,20}$/;
            if (this.username == "") {
                // 非空验证，设置错误信息，开启错误提示
                this.error_username_message = "用户名不能为空";
                this.error_username = true;
            }
            else if (re.test(this.username)) {
                // 经校验符合正则，关闭错误提示
                this.error_username = false;
            }

            else {
                // 经校验不符合正则，设置错误提示并开启
                this.error_username = true;
            }
            // 在正则通过的前提下校验重名

        },
        // 校验字段2
        check_pwd: function () {
            // 匹配正则
            var re = /^[0-9A-Za-z]{8,20}$/;
            if (this.password == "") {
                // 非空验证，设置错误信息，开启错误提示
                this.error_password_message = "密码不能为空";
                this.error_password = true;
            }
            else if (re.test(this.password)) {
                // 经校验符合正则，关闭错误提示
                this.error_password = false;
            }

            else {
                // 经校验不符合正则，设置错误提示并开启
                this.error_password = true;
            }
        },
        // 校验字段3
        check_cpwd: function () {
            // 校验此字符串与password是否一致
            if (this.password2 == "") {
                // 非空验证，设置错误信息，开启错误提示
                this.error_password2_message = "确认密码字段不能为空";
                this.error_check_password = true;
            }
            else if (this.password == this.password2) {
                // 经校验一致，关闭错误提示
                this.error_check_password = false;
            }

            else {
                // 经校验不一致，开启错误提示
                this.error_check_password = true;
            }
        },
        // 校验字段4
        check_phone: function () {
            // 正则校验电话号
            var re = /^1[345789]\d{9}$/;
            if (re.test(this.mobile)) {
                // 经校验符合正则，关闭错误提示
                this.error_phone = false;
            }
            else if (this.mobile == "") {
                // 非空验证，设置错误信息，开启错误提示
                this.error_phone_message = "电话号码不能为空";
                this.error_phone = true;
            }
            else {
                // 经校验不符合正则，设置错误信息后开启错误提示
                this.error_phone = true;
            }
        },
        // 校验字段5
        check_allow: function () {
            // 校验是否勾选
            if (this.allow == true) {
                // 经校验已勾选，关闭错误提示
                this.error_allow = false;
            }
            else {
                // 经校验未勾选，开启错误提示
                this.error_allow = true;
            }
        },
        //校验图形验证码
        check_image_code: function () {
            // 校验非空
            if (this.image_code == "") {
                this.error_image_code_message = "图形验证码不能为空";
                this.error_image_code = true;
            }
        },
        // 校验短信验证码
        check_sms_code:function(){
            // 校验非空
            if(this.sms_code == ""){
                this.error_sms_code_message = "短信验证码不能为空"
                this.error_sms_code = true;

            }

        },
        // 发送短信验证码
        send_sms_code:function(){
            if(this.sending_flag == true){
                return;
            }
            this.sending_flag = true;

            // 校验参数,保证输入框中数据非空
            this.check_phone();
            this.check_image_code();

            if(this.error_image_code == true || this.check_phone == true){
                this.sending_flag == false;
                return;
            }

            // 向后端发送ajax请求,调用发送验证码方法
            var url = this.host + '/sms_codes/' + this.mobile + '/?image_code=' + this.image_code + '&image_code_id=' + this.image_code_id;
            axios.get(url, {
                responseType:'json'
            }).then(response=>{
                if(response.data.code == '0'){
                    // 倒计时60秒，60秒后允许用户再次点击发送短信验证码的按钮
                    var num = 60;
                    // 设置一个计时器
                    var t = setInterval(() => {
                        if (num == 1) {
                            // 如果计时器到最后, 清除计时器对象
                            clearInterval(t);
                            // 将点击获取验证码的按钮展示的文本回复成原始文本
                            this.sms_code_tip = '获取短信验证码';
                            // 将点击按钮的onclick事件函数恢复回去
                            this.sending_flag = false;
                        } else {
                            num -= 1;
                            // 展示倒计时信息
                            this.sms_code_tip = num + '秒';
                        }
                    }, 1000, 60)
                }
                else{
                    if (response.data.code == '4001') {
                        this.error_image_code_message = response.data.errmsg;
                        this.error_image_code = true;
                    } else { // 4002
                        this.error_sms_code_message = response.data.errmsg;
                        this.error_sms_code = true;
                    }
                    this.generate_image_code();
                    this.sending_flag = false;
                }
            }).catch(error=>{
                console.log(error.response);
                this.sending_flag = false;
            })

        },
        // 提交表单
        on_submit() {
            this.check_username();
            this.check_pwd();
            this.check_cpwd();
            this.check_phone();
            this.check_sms_code();
            this.check_allow();

            if (this.error_name == true || this.error_password == true || this.error_check_password == true
                || this.error_phone == true || this.error_sms_code == true || this.error_allow == true) {
                // 不满足注册条件：禁用表单
                window.event.returnValue = false;
            }

            // var url = this.host + "/register/";
            // axios.post(url, {
            //     username = this.username,
            //     password = this.password,
            //     password2 = this.password2,
            //     mobile = this.mobile,
            //     allow = this.allow
            // }, {
            //     responseType:'json'
            // }).then(response=>{}).catch(error=>{});
        }
    }
});